<script>
export default {
  name: 'Carousel',
  props: {
    startingImage: {
      type: Number,
      required: false,
      default: null,
    },
    images: {
      type: Array,
      required: true,
      default: null,
    },
    autoSlideInterval: {
      type: Number,
      required: false,
      default: null,
    },
    showProgressBar: {
      type: Boolean,
      required: false,
      default: false,
    },
    actions: {
      type: Boolean,
      required: false,
      default: false,
    },
    imageCopy: {
      type: String,
      required: false,
      default: '',
    },
  },
  data() {
    return {
      activeImage: 0,
      autoSlideTimeout: null,
      stopSlider: false,
      timeLeft: 0,
      timerInterval: null,
      countdownInterval: 10,
      progressBarWidth: 100 / this.images.length,
    };
  },
  computed: {
    currentImage() {
      // eslint-disable-next-line
      this.timeLeft = this.autoSlideInterval;
      return this.activeImage;
    },
    progressBar() {
      return 100 - (this.timeLeft / this.autoSlideInterval) * 100;
    },
  },
  created() {
    if (
      this.startingImage &&
      this.startingImage >= 0 &&
      this.startingImage < this.images.length
    ) {
      this.activeImage = this.startingImage;
    }
    if (
      this.autoSlideInterval &&
      this.autoSlideInterval > this.countdownInterval
    ) {
      this.startTimer(this.autoSlideInterval);
      this.timeLeft = this.autoSlideInterval;
      this.startCountdown();
    }
  },
  methods: {
    nextImage() {
      let active = this.activeImage + 1;
      if (active >= this.images.length) {
        active = 0;
      }
      this.activateImage(active);
    },
    prevImage() {
      let active = this.activeImage - 1;
      if (active < 0) {
        active = this.images.length - 1;
      }
      this.activateImage(active);
    },
    activateImage(imageIndex) {
      this.activeImage = imageIndex;
    },
    startTimer(interval) {
      if (interval && interval > 0 && !this.stopSlider) {
        const self = this;
        clearTimeout(this.autoSlideTimeout);
        this.autoSlideTimeout = setTimeout(() => {
          self.nextImage();
          self.startTimer(self.autoSlideInterval);
        }, interval);
      }
    },
    stopTimer() {
      clearTimeout(this.autoSlideTimeout);
      this.stopSlider = true;
      clearInterval(this.timerInterval);
    },
    restartTimer() {
      this.stopSlider = false;
      clearInterval(this.timerInterval);
      this.startCountdown();
      this.startTimer(this.timeLeft);
    },
    startCountdown() {
      if (!this.showProgressBar) return;
      const self = this;
      this.timerInterval = setInterval(() => {
        self.timeLeft -= self.countdownInterval;
        if (self.timeLeft <= 0) {
          self.timeLeft = self.autoSlideInterval;
        }
      }, this.countdownInterval);
    },
  },
};
</script>

<template>
  <div class="card-carousel">
    <!-- <SlpTypography
      v-if="imageCopy"
      tag="p"
      variant="heading5-bold"
      class="desktop"
      >{{ imageCopy }}</SlpTypography
    > -->
    <div class="card-img">
      <div
        v-for="(image, index) in images"
        :key="image.id"
        class="card-img__image"
        :class="{ active: currentImage == index }"
      >
        <nuxt-img
          :src="image.image"
          :alt="image.alt"
          @mouseover="stopTimer"
          @mouseleave="restartTimer"
        />
      </div>
      <div v-if="actions" class="actions">
        <span class="prev" @click="prevImage"> &#8249; </span>
        <span class="next" @click="nextImage"> &#8250; </span>
      </div>
    </div>
    <SlpTypography
      v-if="imageCopy"
      tag="p"
      variant="heading5-bold"
      class="mobile"
      >{{ imageCopy }}</SlpTypography
    >
    <div
      v-if="autoSlideInterval && showProgressBar"
      class="progressbar-container"
    >
      <div
        v-for="(image, index) in images"
        :key="image.id"
        class="progressbar"
        :style="{ width: progressBarWidth + '%' }"
      >
        <div
          :style="{ width: progressBar + '%' }"
          :class="{ active: currentImage == index }"
        ></div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.card-carousel {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  align-items: center;

  p.desktop {
    margin-bottom: $spacing-8;
  }

  p.mobile {
    display: none;
    margin-top: $spacing-8;
  }

  @media (max-width: $breakpoint-md) {
    p.desktop {
      display: none;
    }
    p.mobile {
      display: block;
    }
  }
}
.progressbar {
  display: block;
  margin-right: $spacing-24;
  height: 2px;
  background: #e8e7eb;
  z-index: 1;
  & > div {
    height: 100%;
    opacity: 0;
    width: 0;
    &.active {
      background-color: #171321;
      opacity: 1;
    }
  }
  &:last-of-type {
    margin-right: 0;
  }
}
.card-img {
  margin-bottom: $spacing-16;
  padding-bottom: 75%;
  position: relative;
  width: 100%;

  &__image {
    opacity: 0;
    position: absolute;
    width: 100%;
    height: 100%;
    transition: opacity 0.6s ease-in-out;
    &.active {
      opacity: 1;
    }
  }
}
.card-img__image > img {
  display: block;
  margin: 0 auto;

  max-width: 100%;
  transform: translateY(40px);
  @media (min-width: $breakpoint-lg) {
    transform: scale(1.1) translateY(75px);
  }
}
.actions {
  font-size: 1.5em;
  height: 40px;
  position: absolute;
  top: 50%;
  margin-top: -20px;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: space-between;
  color: #585858;
}
.actions > span {
  cursor: pointer;
  transition: all 250ms;
  font-size: 45px;
}
.actions > span.prev {
  margin-left: 5px;
}
.actions > span.next {
  margin-right: 5px;
}
.actions > span:hover {
  color: #eee;
}
.progressbar-container {
  display: flex;
  width: 100%;
  margin: $spacing-32 0 $spacing-48 0;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 0 0;
    bottom: 0;
    position: absolute;
    left: 0;
    max-width: 300px;
  }
  @media (min-width: $breakpoint-lg) {
    margin: $spacing-16 0;
    max-width: 390px;
  }
}
</style>
